
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef aspect_POSTER_LIB_H
#define aspect_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "aspectType.h"
#include "aspectError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[ASPECT_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} ASPECT_CNTRL_STR;

/* For consistency with other posters */
typedef ASPECT_CNTRL_STR ASPECT_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "aspectPosterLibStruct.h"



/* Posters */
#define ASPECT_CNTRL_POSTER_NAME genomInstanceSuffixName("aspect", "Cntrl")
#define ASPECT_CARTESIANASPECT_POSTER_NAME genomInstanceSuffixName("aspect", "CartesianAspect")
#define ASPECT_POLARASPECT_POSTER_NAME genomInstanceSuffixName("aspect", "PolarAspect")
#define ASPECT_LASERECHOS_POSTER_NAME genomInstanceSuffixName("aspect", "LaserEchos")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS aspectPosterInit ( void );
extern POSTER_ID aspectCntrlPosterID ();
extern STATUS aspectCntrlPosterRead ( ASPECT_CNTRL_STR *aspectCntrlStrId );
extern STATUS aspectCntrlPosterInit ( void );
extern STATUS aspectCntrlInstancePosterRead(const char *name, ASPECT_CNTRL_STR *aspectCntrlStrId);
extern STATUS aspectCartesianAspectPosterInit ( void );
extern POSTER_ID aspectCartesianAspectPosterID ( void );
extern STATUS aspectCartesianAspectPosterRead ( ASPECT_CARTESIANASPECT_POSTER_STR *x );
extern STATUS aspectCartesianAspectInstancePosterRead ( const char *, ASPECT_CARTESIANASPECT_POSTER_STR * );
extern STATUS aspectCartesianAspectHeaderPosterRead ( SICK_SEG_HEADER *Header );
extern STATUS aspectCartesianAspectHeaderInstancePosterRead( const char *, SICK_SEG_HEADER * );
extern STATUS aspectCartesianAspectSegsPosterRead ( SICK_SEGS *Segs );
extern STATUS aspectCartesianAspectSegsInstancePosterRead( const char *, SICK_SEGS * );
extern STATUS aspectCartesianAspectPointsPosterRead ( SICK_LONELY_PTS *Points );
extern STATUS aspectCartesianAspectPointsInstancePosterRead( const char *, SICK_LONELY_PTS * );
extern STATUS aspectPolarAspectPosterInit ( void );
extern POSTER_ID aspectPolarAspectPosterID ( void );
extern STATUS aspectPolarAspectPosterRead ( ASPECT_POLARASPECT_POSTER_STR *x );
extern STATUS aspectPolarAspectInstancePosterRead ( const char *, ASPECT_POLARASPECT_POSTER_STR * );
extern STATUS aspectPolarAspectHeaderPosterRead ( SICK_SEG_HEADER *Header );
extern STATUS aspectPolarAspectHeaderInstancePosterRead( const char *, SICK_SEG_HEADER * );
extern STATUS aspectPolarAspectPolarSegsPosterRead ( ASPECT_POLAR_SEGS *PolarSegs );
extern STATUS aspectPolarAspectPolarSegsInstancePosterRead( const char *, ASPECT_POLAR_SEGS * );
extern STATUS aspectPolarAspectPointsPosterRead ( SICK_LONELY_PTS *Points );
extern STATUS aspectPolarAspectPointsInstancePosterRead( const char *, SICK_LONELY_PTS * );
extern STATUS aspectPolarAspectSegsTypePosterRead ( ASPECT_SEGS_TYPE *SegsType );
extern STATUS aspectPolarAspectSegsTypeInstancePosterRead( const char *, ASPECT_SEGS_TYPE * );
extern STATUS aspectLaserEchosPosterInit ( void );
extern POSTER_ID aspectLaserEchosPosterID ( void );
extern STATUS aspectLaserEchosPosterRead ( ASPECT_LASERECHOS_POSTER_STR *x );
extern STATUS aspectLaserEchosInstancePosterRead ( const char *, ASPECT_LASERECHOS_POSTER_STR * );
extern STATUS aspectLaserEchosScanPolarPosterRead ( SICK_SCANPOLAR_POSTER_STR *ScanPolar );
extern STATUS aspectLaserEchosScanPolarInstancePosterRead( const char *, SICK_SCANPOLAR_POSTER_STR * );
#ifdef __cplusplus
}
#endif
#endif

